      program trase
      use fortrantl
      implicit none
c     
      integer steps, stepmax, dim, i, j
      parameter (stepmax=100)
      real(dblprec) eta(stepmax), delta, distold, distnew
      complex(dblprec) enstart, encom, energy(stepmax)
      complex(dblprec) en1cor(2:stepmax-1)
      complex(dblprec) der1(stepmax-1), cor1(2:stepmax-1) 
      complex(dblprec) der2(2:stepmax-2), cor2(3:stepmax-2)
      character(36) flin, flout
c
c      write(6,*) 'Input file:'
c      read(5,*) flin
      flin = 'traj.dat'
c      write(6,*) 'Output file:'
c      read(5,*) flout
      flout = 'traj.sel'
      write(6,*) 'First energy along trajectory:'
      read(5,*) enstart
c
c
      open(unit=10,file=flin,
     &     access='sequential',status='old',form='formatted')
c
      read(unit=10,fmt=*,end=10,err=10) dim
      read(unit=10,fmt=*,end=10,err=10) eta(1)
      do j = 1,dim
         read(unit=10,fmt=*,end=10,err=10) encom
         if (j .eq. 1) then
            distold = abs(encom-enstart)
            energy(1) = encom
         else if (j .gt. 1) then
            distnew = abs(encom-enstart)
            if (distnew .lt. distold) then
               energy(1) = encom
               distold = distnew
            end if
         end if
      end do
      steps = 1
c
      do i = 2,stepmax
         read(unit=10,fmt=*,end=10,err=10) dim
         read(unit=10,fmt=*,end=10,err=10) eta(i)
         do j = 1,dim
            read(unit=10,fmt=*,end=10,err=10) encom  
            if (j .eq. 1) then
               distold = abs(encom-energy(i-1))
               energy(i) = encom
            else if (j .gt. 1) then
               distnew = abs(encom-energy(i-1))
               if (distnew .lt. distold) then
                  energy(i) = encom
                  distold = distnew
               end if
            end if
         end do
         steps = steps +1 
      end do
 10   close(unit=10)
c
c
      if (eta(1) .eq. 0.0d0) then
         j = 2
      else
         j = 1
      end if
      do i = j,steps-1
         delta = dlog(eta(i+1)/eta(i))
         der1(i) = (energy(i+1)-energy(i))/delta
      end do
      do i = j+1,steps-1
         cor1(i) = 0.5d0*(der1(i-1)+der1(i))
         en1cor(i) = energy(i)-cor1(i)
      end do
      do i = j+1,steps-2
         delta = dlog(eta(i+1)/eta(i))
         der2(i) = (en1cor(i+1)-en1cor(i))/delta
      end do
      do i = j+2,steps-2
         cor2(i) = 0.25d0*(der2(i-1)+der2(i))
      end do
c       
      open(unit=20,file=flout,
     &     access='sequential',status='unknown',form='formatted')     
      do i = j+2,steps-2
         write(unit=20,fmt=100) eta(i), dble(energy(i)), 
     &        aimag(energy(i)), abs(cor1(i)), 
     &        dble(en1cor(i)), aimag(en1cor(i)), abs(cor2(i))
 100     format(D10.4,6F18.10)
      end do   
      close(unit=20)
c
c
      end
